# Kubernetes Basics - Storage

### This lab will cover the following topics:

* PersistentVolumes
* PersistentVolumeClaims

<br/>
<br/>

---
---

## Lab 1 - Storage

On-disk files in a container are ephemeral, which presents some problems for non-trivial applications when running in containers.

One problem occurs when a container crashes or is stopped. The container state is not saved so all of the files that were created or modified during the lifetime of the container are lost. During a crash, kubelet restarts the container with a clean state. Another problem occurs when multiple containers are running in a Pod and need to share files. It can be challenging to setup and access a shared filesystem across all of the containers.

The Kubernetes volume abstraction solves both of these problems. For this lab, the `local-path` provisioner built into the lab Kubernetes cluster will be used for simplicity.

<br/>

---

<br/>

### Useful Links

* [Persistent Volumes](https://kubernetes.io/docs/concepts/storage/persistent-volumes/)
* [Storage Classes](https://kubernetes.io/docs/concepts/storage/storage-classes/)
* [Dynamic Volume Provisioning](https://kubernetes.io/docs/concepts/storage/dynamic-provisioning/)

<br/>

---

<br/>

### Change the Working Directory

Change to the Storage directory:<br/>
`cd /ab/labs/kubernetes/k8s-basics/7-storage` {{ execute }}

<br/>

---

<br/>

### Review the Storage Lab Manifest

Open and review the Storage manifest:<br/>
`/ab/labs/kubernetes/k8s-basics/7-storage/storage-lab.yml` {{ open }}

> **NOTE:**<br/>This manifest defines a Persistent Volume (PV), a Persistent Volume Claim (PVC), and a Deployment which mounts the PersistentVolumeClaim (PVC) as a volume.

<br/>

---

<br/>

### Apply the Storage Lab Manifest

Apply the Storage manifest:<br/>
`kubectl apply -f storage-lab.yml` {{ execute }}

<br/>

---

<br/>

### Verify the Storage Deployment

Review the Pods, PV, and PVC with kubectl:<br/>
`kubectl get pv,pvc,pod -n training-lab` {{ execute }}

> **NOTE:**<br/>The `kubectl get` command can be used to query more than one resource at a time. In this example, the `pv`, `pvc`, and `pod` resources are queried.

<br/>

---

<br/>

### Create a File on the Attached Storage

Use the `exec` command to create create a file in the Pod:<br/>
`kubectl exec -it -n training-lab $(kubectl get pods -n training-lab -o name | head -n1) -- sh -c "echo 'Hello from the AlphaBravo Lab PV' > /data/hostname.txt"` {{ execute }}

#### What's Happening Here?
1. `kubectl get pods -n training-lab -o name | head -n1` is used to get the name of the first Pod in the `training-lab` Namespace.
2. The `kubectl exec` command is used to execute a command in the Pod.
3. The `-- sh -c "echo 'Hello from the AlphaBravo Lab PV' > /data/hostname.txt"` command is executed in the Pod.
4. A file is created, `/data/hostname.txt`, and has the text `"Hello from the AlphaBravo Lab PV"` written.

> **NOTE:**<br/>Nesting commands within other commands is a common practice in Linux, and useful in Kubernetes to simplify the execution of complex commands that require multiple steps.

<br/>

---

<br/>

### Verify the File was Created

Verify the file was created:<br/>
`kubectl exec -it -n training-lab $(kubectl get pods -n training-lab -o name | head -n1) -- cat /data/hostname.txt` {{ execute }}

> **NOTE:**<br/>Similar to the last example, the `kubectl exec` command is used to execute a command in the Pod. This time, the `cat /data/hostname.txt` command is executed and the output is displayed on the command line.

<br/>

---

<br/>

### Delete the Pod

Delete the Pod to demonstrate the persistent storage:<br/>
`kubectl delete $(kubectl get pods -n training-lab -o name | head -n1) -n training-lab` {{ execute }}

> **NOTE:**<br/>The deletion of the Pod may take a few moments to complete due to way Kubernetes handles the deletion of Pods.

> **NOTE:**<br/>If persistent storage was not used, the `/data/hostname.txt` file would be deleted along with the Pod.

> **NOTE:**<br/>As the Pod was deleted, the Deployment will automatically create a new Pod to replace it. This is the default behavior of Deployments.

<br/>

---

<br/>

### Query the Storage from a New Pod

Query the new pod to determine if the `/data/hostname.txt` file still exists:<br/>
`kubectl exec -it -n training-lab $(kubectl get pods -n training-lab -o name | head -n1) -- cat /data/hostname.txt` {{ execute }}

> **NOTE:**<br/>The text, `"Hello from the AlphaBravo Lab PV"`, should be displayed on the command line.

> **NOTE:**<br/>As seen in the demonstration, using PersistentVolumes and PersistentVolumeClaims allows data to be stored and persist longer than the lifecycle of a single pod.

<br/>

---

<br/>

### Cleanup

Run the following command to cleanup the lab environment:<br/>
`kubectl delete -f /ab/labs/kubernetes/k8s-basics/7-storage` {{ execute }}

<br/>
<br/>

---
---

**Congrats! You have completed the Storage labs.**